## flann 1.8.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

if(COMMAND cmake_policy)
    cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

project(flann)
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)

include(${PROJECT_SOURCE_DIR}/cmake/flann_utils.cmake)
set(FLANN_VERSION 1.8.4)
DISSECT_VERSION()
GET_OS_INFO()

# CMAKE_C_COMPILER_ID and CMAKE_CXX_COMPILER_ID are documented as internal variables subject to
# change at: http://www.cmake.org/cmake/help/v2.8.8/cmake.html#variable:CMAKE_LANG_COMPILER_ID
# however currently this seems the most robust way to detect the presence of the Clang compiler
if("${CMAKE_C_COMPILER_ID}" MATCHES "Clang")
  set(CMAKE_COMPILER_IS_CLANG 1)
endif ()

if("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
  set(CMAKE_COMPILER_IS_CLANGXX 1)
endif ()

list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

# Add an "uninstall" target
CONFIGURE_FILE ("${PROJECT_SOURCE_DIR}/cmake/uninstall_target.cmake.in"
    "${PROJECT_BINARY_DIR}/uninstall_target.cmake" IMMEDIATE @ONLY)
ADD_CUSTOM_TARGET (uninstall "${CMAKE_COMMAND}" -P
    "${PROJECT_BINARY_DIR}/uninstall_target.cmake")

# Set the build type.  Options are:
#  Debug          : w/ debug symbols, w/o optimization
#  Release        : w/o debug symbols, w/ optimization
#  RelWithDebInfo : w/ debug symbols, w/ optimization
#  MinSizeRel     : w/o debug symbols, w/ optimization, stripped binaries

if (NOT CMAKE_BUILD_TYPE)
    #set(CMAKE_BUILD_TYPE Release)
    set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Build type" FORCE)
    #set(CMAKE_BUILD_TYPE Debug)
endif()

#set the default path for built executables to the "bin" directory
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
#set the default path for built libraries to the "lib" directory
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)
# set output path for tests
set(TEST_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/test)

option(BUILD_C_BINDINGS "Build C bindings" ON)
option(BUILD_PYTHON_BINDINGS "Build Python bindings" ON)
option(BUILD_MATLAB_BINDINGS "Build Matlab bindings" ON)
option(BUILD_CUDA_LIB "Build CUDA library" OFF)
option(USE_OPENMP "Use OpenMP multi-threading" ON)
option(USE_MPI "Use MPI" OFF)

set(NVCC_COMPILER_BINDIR "" CACHE PATH  "Directory where nvcc should look for C++ compiler. This is passed to nvcc through the --compiler-bindir option.")

if (NOT BUILD_C_BINDINGS)
    set(BUILD_PYTHON_BINDINGS OFF)
    set(BUILD_MATLAB_BINDINGS OFF)
endif()


# find python
find_package(PythonInterp)
if (NOT PYTHON_EXECUTABLE)
    set(BUILD_PYTHON_BINDINGS OFF)
endif()

find_hdf5()
if (NOT HDF5_FOUND)
	message(WARNING "hdf5 library not found, some tests will not be run")
else()
    include_directories(${HDF5_INCLUDE_DIR})
endif()

if (USE_MPI OR HDF5_IS_PARALLEL)
    find_package(MPI)
endif()
if (HDF5_IS_PARALLEL)
    if (NOT MPI_FOUND)
        message(WARNING "Found the parallel HDF5 library, but could not find the MPI library. Define the MPI_COMPILER variable to the path of your MPI compiler.")
    endif()
    # Parallel HDF5 needs to find the "mpi.h" header file
    include_directories(${MPI_INCLUDE_PATH})
endif()


if (USE_MPI)
    if (NOT MPI_FOUND)
        message(WARNING "Could not find an MPI library. Define the MPI_COMPILER variable to the path of your MPI compiler.")
        set(USE_MPI OFF)
    endif()

    if (NOT HDF5_IS_PARALLEL)
        message(WARNING "For MPI support the Parallel HDF5 library is required.")
        set(USE_MPI OFF)
    endif()
endif(USE_MPI)


if (USE_MPI AND HDF5_IS_PARALLEL)
    find_package(Boost COMPONENTS mpi system serialization thread REQUIRED)
    include_directories(${Boost_INCLUDE_DIRS})
    add_definitions("-DHAVE_MPI")
endif()


find_package(GTest) 
if (NOT GTEST_FOUND)
	message(WARNING "gtest library not found, some tests will not be run")
endif()


if (USE_OPENMP)
    find_package(OpenMP)
    if(OPENMP_FOUND)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")
    else()
        message(WARNING "OpenMP NOT found")
    endif()
endif()


# CUDA support
if (BUILD_CUDA_LIB)
    find_package(CUDA)
    if (CUDA_FOUND)
        message(STATUS "CUDA found (include: ${CUDA_INCLUDE_DIRS}, lib: ${CUDA_LIBRARIES})")
        include_directories(${CUDA_INCLUDE_DIRS})
    else(CUDA_FOUND)
        message(STATUS "CUDA not found, CUDA library will not be built")
        set(BUILD_CUDA_LIB OFF)
    endif(CUDA_FOUND)
endif(BUILD_CUDA_LIB)

#set the C/C++ include path to the "include" directory
include_directories(${PROJECT_SOURCE_DIR}/src/cpp)

# require proper c++
#add_definitions( "-Wall -ansi -pedantic" )
# HDF5 uses long long which is not ansi
if (WIN32)
    # lots of warnings with cl.exe right now, use /W1
    add_definitions("/W1 -D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS /bigobj")
else(WIN32)
    add_definitions( "-Wall -Wno-unknown-pragmas -Wno-unused-function" )
endif(WIN32)

add_subdirectory( cmake )
add_subdirectory( src )
add_subdirectory( examples )
add_subdirectory( test )
add_subdirectory( doc )


# CPACK options

# RPM
find_program(RPM_PROGRAM rpm)
if(EXISTS ${RPM_PROGRAM})
  list(APPEND CPACK_GENERATOR "RPM")
endif(EXISTS ${RPM_PROGRAM})
# DEB
find_program(DPKG_PROGRAM dpkg)
if(EXISTS ${DPKG_PROGRAM})
  list(APPEND CPACK_GENERATOR "DEB")
endif(EXISTS ${DPKG_PROGRAM})
# NSIS
find_program(NSIS_PROGRAM makensis MakeNSIS)
if(EXISTS ${NSIS_PROGRAM})
  list(APPEND CPACK_GENERATOR "NSIS")
endif(EXISTS ${NSIS_PROGRAM})
# dpkg
find_program(PACKAGE_MAKER_PROGRAM PackageMaker
	    HINTS /Developer/Applications/Utilities)
if(EXISTS ${PACKAGE_MAKER_PROGRAM})
  list(APPEND CPACK_GENERATOR "PackageMaker")
endif(EXISTS ${PACKAGE_MAKER_PROGRAM})
 
set(CPACK_GENERATOR "${CPACK_GENERATOR}")
set(CPACK_MONOLITHIC_INSTALL 1)
set(CPACK_SET_DESTDIR ON)
include(InstallRequiredSystemLibraries)
set(CPACK_PACKAGE_CONTACT "Marius Muja")
set(CPACK_PACKAGING_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
SET(CPACK_PACKAGE_VERSION ${FLANN_VERSION})
SET(CPACK_PACKAGE_VERSION_MAJOR ${FLANN_VERSION_MAJOR})
SET(CPACK_PACKAGE_VERSION_MINOR ${FLANN_VERSION_MINOR})
SET(CPACK_PACKAGE_VERSION_PATCH ${FLANN_VERSION_PATCH})
include(CPack)


message(STATUS "Install prefix: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")
message(STATUS "Building C bindings: ${BUILD_C_BINDINGS}")
message(STATUS "Building python bindings: ${BUILD_PYTHON_BINDINGS}")
message(STATUS "Building matlab bindings: ${BUILD_MATLAB_BINDINGS}")
message(STATUS "Building CUDA library: ${BUILD_CUDA_LIB}")
message(STATUS "Using OpenMP support: ${USE_OPENMP}")
message(STATUS "Using MPI support: ${USE_MPI}")

=== doc/CMakeLists.txt ===
find_package(LATEX)
 
if (EXISTS ${PDFLATEX_COMPILER} AND EXISTS ${BIBTEX_COMPILER})
    include(${PROJECT_SOURCE_DIR}/cmake/UseLATEX.cmake)

    add_latex_document(manual.tex BIBFILES references.bib IMAGE_DIRS images DEFAULT_PDF)

    add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/manual.pdf
        COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_BINARY_DIR}/manual.pdf ${CMAKE_CURRENT_SOURCE_DIR}/manual.pdf
        DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/manual.pdf
    )
    add_custom_target(doc DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/manual.pdf)
endif()

install(
    FILES manual.pdf
    DESTINATION share/doc/flann
    OPTIONAL
)

=== examples/CMakeLists.txt ===
add_custom_target(examples ALL)


if (BUILD_C_BINDINGS)
    add_executable(flann_example_c flann_example.c)
    target_link_libraries(flann_example_c flann)
    set_target_properties(flann_example_c PROPERTIES COMPILE_FLAGS -std=c99)

    add_dependencies(examples flann_example_c)
    install (TARGETS flann_example_c DESTINATION bin )
endif()

if (HDF5_FOUND)
    include_directories(${HDF5_INCLUDE_DIR})

    add_executable(flann_example_cpp flann_example.cpp)
    target_link_libraries(flann_example_cpp ${HDF5_LIBRARIES})
    if (HDF5_IS_PARALLEL)
        target_link_libraries(flann_example_cpp ${MPI_LIBRARIES})
    endif()

    add_dependencies(examples flann_example_cpp)
    install (TARGETS flann_example_cpp DESTINATION bin)


    if (USE_MPI AND HDF5_IS_PARALLEL)
        add_executable(flann_example_mpi flann_example_mpi.cpp)
        target_link_libraries(flann_example_mpi flann_cpp ${HDF5_LIBRARIES} ${MPI_LIBRARIES} ${Boost_LIBRARIES})

        add_dependencies(examples flann_example_mpi)
        install (TARGETS flann_example_mpi DESTINATION bin)
    endif()
else()
    message("hdf5 library not found, not compiling flann_example.cpp")
endif()

=== src/cpp/CMakeLists.txt ===
#include_directories(${CMAKE_SOURCE_DIR}/include algorithms util nn .)

add_definitions(-D_FLANN_VERSION=${FLANN_VERSION})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/flann/config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/flann/config.h)

file(GLOB_RECURSE C_SOURCES flann.cpp)
file(GLOB_RECURSE CPP_SOURCES flann_cpp.cpp)
file(GLOB_RECURSE CU_SOURCES *.cu)

add_library(flann_cpp_s STATIC ${CPP_SOURCES})
if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_CLANG)
    set_target_properties(flann_cpp_s PROPERTIES COMPILE_FLAGS -fPIC)
endif()
set_property(TARGET flann_cpp_s PROPERTY COMPILE_DEFINITIONS FLANN_STATIC FLANN_USE_CUDA)

if (BUILD_CUDA_LIB)
    SET(CUDA_NVCC_FLAGS -DFLANN_USE_CUDA)
    if(CMAKE_COMPILER_IS_GNUCC)
		set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS};-Xcompiler;-fPIC;-arch=sm_13" )
        if (NVCC_COMPILER_BINDIR)
            set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS};--compiler-bindir=${NVCC_COMPILER_BINDIR}")
        endif()
    else()
	    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS};-arch=sm_13" )
    endif()
    cuda_add_library(flann_cuda_s STATIC ${CU_SOURCES})
    set_property(TARGET flann_cuda_s PROPERTY COMPILE_DEFINITIONS FLANN_STATIC)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "Linux" AND CMAKE_COMPILER_IS_GNUCC)
    add_library(flann_cpp SHARED "")
    set_target_properties(flann_cpp PROPERTIES LINKER_LANGUAGE CXX)
    target_link_libraries(flann_cpp -Wl,-whole-archive flann_cpp_s -Wl,-no-whole-archive)

    if (BUILD_CUDA_LIB)
	    cuda_add_library(flann_cuda SHARED "")
        set_target_properties(flann_cuda PROPERTIES LINKER_LANGUAGE CXX)
        target_link_libraries(flann_cuda -Wl,-whole-archive flann_cuda_s -Wl,-no-whole-archive)
        set_property(TARGET flann_cpp_s PROPERTY COMPILE_DEFINITIONS FLANN_USE_CUDA)
    # 	target_link_libraries(flann_cuda cudpp_x86_64)
    endif()
else()
    add_library(flann_cpp SHARED ${CPP_SOURCES})
    if (BUILD_CUDA_LIB)
		cuda_add_library(flann_cuda SHARED ${CPP_SOURCES})
        set_property(TARGET flann_cpp PROPERTY COMPILE_DEFINITIONS FLANN_USE_CUDA)
    endif()
endif()

set_target_properties(flann_cpp PROPERTIES
   VERSION ${FLANN_VERSION}
   SOVERSION ${FLANN_SOVERSION}
   DEFINE_SYMBOL FLANN_EXPORTS
) 

if (BUILD_CUDA_LIB)
    set_target_properties(flann_cuda PROPERTIES
       VERSION ${FLANN_VERSION}
       SOVERSION ${FLANN_SOVERSION}
       DEFINE_SYMBOL FLANN_EXPORTS
    ) 
endif()


if (USE_MPI AND HDF5_IS_PARALLEL)
    add_executable(flann_mpi_server flann/mpi/flann_mpi_server.cpp)
    target_link_libraries(flann_mpi_server flann_cpp ${HDF5_LIBRARIES} ${MPI_LIBRARIES} ${Boost_LIBRARIES})

    add_executable(flann_mpi_client flann/mpi/flann_mpi_client.cpp)
    target_link_libraries(flann_mpi_client flann_cpp ${HDF5_LIBRARIES} ${MPI_LIBRARIES} ${Boost_LIBRARIES})

    install (TARGETS flann_mpi_client flann_mpi_server
        DESTINATION bin)
endif()


if (BUILD_C_BINDINGS)
    add_library(flann_s STATIC ${C_SOURCES})
    if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_CLANG)
        set_target_properties(flann_s PROPERTIES COMPILE_FLAGS -fPIC)
    endif()
    set_property(TARGET flann_s PROPERTY COMPILE_DEFINITIONS FLANN_STATIC)

    if(CMAKE_SYSTEM_NAME STREQUAL "Linux" AND CMAKE_COMPILER_IS_GNUCC)
        add_library(flann SHARED "")
        set_target_properties(flann PROPERTIES LINKER_LANGUAGE CXX)
        target_link_libraries(flann -Wl,-whole-archive flann_s -Wl,-no-whole-archive)
    else()
        add_library(flann SHARED ${C_SOURCES})
    endif()

    set_target_properties(flann PROPERTIES
       VERSION ${FLANN_VERSION}
       SOVERSION ${FLANN_SOVERSION}
       DEFINE_SYMBOL FLANN_EXPORTS
    ) 
endif()

if(WIN32)
if (BUILD_C_BINDINGS)
    install (
        TARGETS flann
        RUNTIME DESTINATION share/flann/matlab
    )
endif()
endif(WIN32)


install (
    TARGETS flann_cpp flann_cpp_s
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION ${FLANN_LIB_INSTALL_DIR}
    ARCHIVE DESTINATION ${FLANN_LIB_INSTALL_DIR}
)
 
if (BUILD_CUDA_LIB)
    install (
        TARGETS flann_cuda flann_cuda_s
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION ${FLANN_LIB_INSTALL_DIR}
        ARCHIVE DESTINATION ${FLANN_LIB_INSTALL_DIR}
    )
endif()

if (BUILD_C_BINDINGS)
    install (
        TARGETS flann flann_s
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION ${FLANN_LIB_INSTALL_DIR}
        ARCHIVE DESTINATION ${FLANN_LIB_INSTALL_DIR}
    )
endif()

install (
    DIRECTORY flann
    DESTINATION include
    FILES_MATCHING PATTERN "*.h" PATTERN "*.hpp"
)

=== src/matlab/CMakeLists.txt ===
#IF(WIN32)
#    SET(MEXEXT_CMD cmd /C mexext)
#ELSE(WIN32)
#    SET(MEXEXT_CMD mexext)
#ENDIF(WIN32)

SET(MEX_NAME nearest_neighbors)

if(WIN32)
    find_program(MEX_CMD mex.bat)
    find_program(MEXEXT_CMD mexext.bat)
else()
    find_program(MEX_CMD mex)
    find_program(MEXEXT_CMD mexext)
endif()

find_program(OCT_CMD mkoctfile)

if(MEX_CMD AND MEXEXT_CMD)

    get_filename_component(MEX_REAL_CMD ${MEX_CMD} ABSOLUTE)
    get_filename_component(MEX_PATH ${MEX_REAL_CMD} PATH)

    get_filename_component(MEXEXT_REAL_CMD ${MEXEXT_CMD} ABSOLUTE)
    get_filename_component(MEXEXT_PATH ${MEXEXT_REAL_CMD} PATH)

    if (MEX_PATH STREQUAL MEXEXT_PATH)
        message(STATUS "Found MATLAB at: " ${MEX_PATH})

        EXECUTE_PROCESS(COMMAND ${MEXEXT_REAL_CMD} OUTPUT_VARIABLE MEX_EXTENSION OUTPUT_STRIP_TRAILING_WHITESPACE)
        SET(MEX_FILE ${CMAKE_CURRENT_BINARY_DIR}/${MEX_NAME}.${MEX_EXTENSION})

        if (WIN32)
            set(MEX_BUILD_FLAGS "COMPFLAGS=\"$$COMPFLAGS ${OpenMP_CXX_FLAGS}\" LINKFLAGS=\"$$LINKFLAGS ${OpenMP_CXX_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}\"")
        else()
            set(MEX_BUILD_FLAGS "CFLAGS='$$CFLAGS ${OpenMP_CXX_FLAGS}' LDFLAGS='$$LDFLAGS ${OpenMP_CXX_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}'")
        endif()
        separate_arguments(MEX_BUILD_FLAGS)

        ADD_CUSTOM_COMMAND(
            OUTPUT ${MEX_FILE}
            COMMAND ${MEX_REAL_CMD}
            ARGS ${CMAKE_CURRENT_SOURCE_DIR}/${MEX_NAME}.cpp -I${PROJECT_SOURCE_DIR}/src/cpp -L${LIBRARY_OUTPUT_PATH} -lflann_s ${MEX_BUILD_FLAGS}
            DEPENDS flann_s ${CMAKE_CURRENT_SOURCE_DIR}/${MEX_NAME}.cpp
            COMMENT "Building MEX extension ${MEX_FILE}"
        )

        ADD_CUSTOM_TARGET(mex_${MEX_NAME} ALL DEPENDS ${MEX_FILE})

        FILE(GLOB MATLAB_SOURCES *.m)

        INSTALL (
            FILES ${MEX_FILE} ${MATLAB_SOURCES}
            DESTINATION share/flann/matlab
        )
    else()
        message(WARNING "The 'mex' and 'mexext' programs have been found in different locations. It's likely that one of them is not part of the MATLAB instalation. Make sure that the 'bin' directory from the MATLAB instalation is in PATH")
        set(BUILD_MATLAB_BINDINGS OFF) 
    endif()
elseif(OCT_CMD)
  SET(MEX_FILE ${CMAKE_CURRENT_BINARY_DIR}/${MEX_NAME}.mex)
  ADD_CUSTOM_COMMAND(
    OUTPUT ${MEX_FILE}
    COMMAND ${OCT_CMD}
    ARGS ${CMAKE_CURRENT_SOURCE_DIR}/${MEX_NAME}.cpp -I${PROJECT_SOURCE_DIR}/src/cpp -L${LIBRARY_OUTPUT_PATH} -DFLANN_STATIC -lflann_s --mex
    DEPENDS flann_s ${CMAKE_CURRENT_SOURCE_DIR}/${MEX_NAME}.cpp
    COMMENT "Building MEX extension ${MEX_FILE}"
    )

  ADD_CUSTOM_TARGET(mex_${MEX_NAME} ALL DEPENDS ${MEX_FILE})

  FILE(GLOB MATLAB_SOURCES *.m)

  INSTALL (
    FILES ${MEX_FILE} ${MATLAB_SOURCES}
    DESTINATION share/flann/octave
    )
else()
    message(WARNING "Cannot find MATLAB or Octave instalation. Make sure that the 'bin' directory from the MATLAB instalation or that mkoctfile is in PATH")
    set(BUILD_MATLAB_BINDINGS OFF) 
endif()

=== debian/changelog ===
flann (1.8.4-3) unstable; urgency=low

  * Do not use CMAKE_BUILD_TYPE. Closes: #731514

 -- Mathieu Malaterre <malat@debian.org>  Sun, 08 Dec 2013 08:15:11 +0100

flann (1.8.4-2) unstable; urgency=low

  * Upload to sid. Closes: #707702

 -- Mathieu Malaterre <malat@debian.org>  Tue, 14 May 2013 14:23:17 +0200

flann (1.8.4-1) experimental; urgency=low

  * New upstream. Fix memleak

 -- Mathieu Malaterre <malat@debian.org>  Sat, 19 Jan 2013 21:17:48 +0100

flann (1.8.3-1) experimental; urgency=low

  * New upstream
  * Switch from tbb to OpenMP
  * Remove hack to get Changelog from web, use upstream instead
  * Remove Breaks/Replace, not needed anymore
  * Bump Std-Vers to 3.9.4, no changes needed
  * remove patch not needed anymore:
    - debian/patches/remove_lib64.patch
  * Remove obsolete DMUA flag
  * Use multiarch lib path

 -- Mathieu Malaterre <malat@debian.org>  Thu, 03 Jan 2013 13:51:42 +0100

=== debian/control ===
Source: flann
Section: libs
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Mathieu Malaterre <malat@debian.org>,
 Michael Kleiber <mike@kleibi.de>
Build-Depends: debhelper (>= 9), cmake (>= 2.6.0),
 libgtest-dev, python, python-numpy, libboost-all-dev,
 mpi-default-dev, libhdf5-mpi-dev
Build-Depends-Indep: texlive-latex-base, texlive-binaries, latex2html
Standards-Version: 3.9.4
Homepage: http://www.cs.ubc.ca/~mariusm/index.php/FLANN/FLANN
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-science/packages/flann/trunk/
Vcs-Svn: svn://svn.debian.org/debian-science/packages/flann/trunk/

Package: libflann-dev
Section: libdevel
Architecture: any
Depends: libflann1.8 (= ${binary:Version}), ${misc:Depends}
Description: Fast Library for Approximate Nearest Neighbors - development
 FLANN is a library for performing fast approximate nearest neighbor searches
 in high dimensional spaces. It contains a collection of algorithms found
 to work best for nearest neighbor search and a system for automatically
 choosing the best algorithm and optimum parameters depending on the dataset.
 .
 This package contains development files needed to build FLANN applications.

Package: libflann1.8
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Fast Library for Approximate Nearest Neighbors - runtime
 FLANN is a library for performing fast approximate nearest neighbor searches
 in high dimensional spaces. It contains a collection of algorithms found
 to work best for nearest neighbor search and a system for automatically
 choosing the best algorithm and optimum parameters depending on the dataset.
 .
 This package contains the libraries needed to run FLANN applications.

Package: flann-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, doc-base
Description: Fast Library for Approximate Nearest Neighbors - documentation
 FLANN is a library for performing fast approximate nearest neighbor searches
 in high dimensional spaces. It contains a collection of algorithms found
 to work best for nearest neighbor search and a system for automatically
 choosing the best algorithm and optimum parameters depending on the dataset.
 .
 This package contains the documentation for FLANN.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CMAKE_FLAGS = \
	-DCMAKE_BUILD_TYPE:STRING=None \
	-DBUILD_MATLAB_BINDINGS:BOOL=OFF \
	-DBUILD_PYTHON_BINDINGS:BOOL=OFF \
	-DUSE_MPI:BOOL=ON \
	-DUSE_OPENMP:BOOL=ON \
	-DFLANN_LIB_INSTALL_DIR:STRING="lib/$(DEB_HOST_MULTIARCH)" \
	-DBUILD_CUDA_LIB:BOOL=OFF

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_auto_test:
	# test download material from the net. Removing them.

override_dh_compress:
	dh_compress --exclude=.pdf

# Let's be smart with building doc
override_dh_auto_build-indep:
	$(MAKE) -C obj-* doc

# No tests needed for docs
override_dh_auto_test-indep:

get-orig-source:
	uscan --verbose --force-download --repack --rename

=== debian/watch ===
version=3
http://www.cs.ubc.ca/~mariusm/index.php/FLANN/FLANN .*flann-(.*)-src.zip

## flann 1.9.1%2Bdfsg

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,7 @@
     include_directories(${HDF5_INCLUDE_DIR})
 
     add_executable(flann_example_cpp flann_example.cpp)
-    target_link_libraries(flann_example_cpp ${HDF5_LIBRARIES})
+    target_link_libraries(flann_example_cpp ${HDF5_LIBRARIES} flann_cpp)
     if (HDF5_IS_PARALLEL)
         target_link_libraries(flann_example_cpp ${MPI_LIBRARIES})
     endif()

=== debian/changelog ===
flann (1.9.1+dfsg-9build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:14:16 +0100

flann (1.9.1+dfsg-9) unstable; urgency=medium

  * Team upload.
  * Don't run dh_dwz on mipsel

 -- Jochen Sprickerhof <jspricke@debian.org>  Wed, 23 Oct 2019 22:22:24 +0200

flann (1.9.1+dfsg-8) unstable; urgency=medium

  * Team upload.
  * Add README.source
  * Drop Python 2 dependencies (Closes: #936519)
  * switch to debhelper-compat and debhelper 12
  * Bump policy version (no changes)
  * add Salsa CI

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 12 Oct 2019 11:53:40 +0200

flann (1.9.1+dfsg-7) unstable; urgency=medium

  * Team upload.
  * Update mips* flags to use less memory (cf. #911497)

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 21 Oct 2018 22:01:59 +0200

flann (1.9.1+dfsg-6) unstable; urgency=medium

  * Team upload.
  * Make sure flann_cpp is linked against lz4

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 15 Oct 2018 22:04:16 +0200

flann (1.9.1+dfsg-5) unstable; urgency=medium

  * Team upload.
  * Fix lz4 linking in pkg-config

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 14 Oct 2018 10:44:31 +0200

flann (1.9.1+dfsg-4) unstable; urgency=medium

  * Team upload.
  * Add patch to use system liblz4 (LP: 1786543)
  * Bump policy version (no changes)
  * Update dependencies
  * Add patch for empty date in manual

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 14 Oct 2018 00:56:02 +0200

flann (1.9.1+dfsg-3) unstable; urgency=medium

  * Team upload.

  [ Mathieu Malaterre ]
  * Remove self from Uploaders

  [ Jochen Sprickerhof ]
  * Add patch for cmake 3.11 (Closes: #897101)
  * Update packaging

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 28 Apr 2018 17:37:51 +0200

flann (1.9.1+dfsg-2) unstable; urgency=medium

  * Upload to unstable
  * New ABI version. Closes: #797718)

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 18 Aug 2016 21:45:00 +0200

flann (1.9.1+dfsg-1) experimental; urgency=medium

  * Added BUILD tests
  * Update watch file to add dfsg suffix
  * Imported Upstream version 1.9.1+dfsg
  * Added myself as uploader
  * Updated to new VCS fields
  * Removed unneeded patch. Move to CMake option
  * Updated patches
  * Set LIB_SUFFIX with DEB_HOST_MULTIARCH
  * Update copyright
  * Bumped Standards-Version to 3.9.8. No changes

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Sat, 13 Aug 2016 19:07:50 +0200

flann (1.8.4-4.2) unstable; urgency=medium

  * Non-maintainer upload.
  * 20_abs-std-abs.patch: 3645f0c30a47267e56e5acdecfc7bac2b76bc3d5 from
    upstream GIT. Use std::abs instead of abs, fixing gcc6 build error.
    Closes: #822717

 -- Andreas Metzler <ametzler@debian.org>  Sat, 30 Jul 2016 15:07:35 +0200

flann (1.8.4-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New patch fix-cmake-hdf5.patch to support hdf5 1.8.13 new packaging
    layout (closes: #756471).

 -- Gilles Filippini <pini@debian.org>  Wed, 06 Aug 2014 08:33:53 +0200

flann (1.8.4-4) unstable; urgency=low

  * Bump Std-Vers to 3.9.5, no changes needed. Run w-a-s for cleanup.
  * Use the ggc-min-expand flag.
    Patch by Dejan Latinovic <Dejan.Latinovic@imgtec.com>.
    Closes: #751478.

 -- Mathieu Malaterre <malat@debian.org>  Tue, 17 Jun 2014 10:57:45 +0200

## flann 1.9.1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,13 +8,12 @@
 string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)
 
 include(${PROJECT_SOURCE_DIR}/cmake/flann_utils.cmake)
-set(FLANN_VERSION 1.8.4)
+set(FLANN_VERSION 1.9.1)
 DISSECT_VERSION()
 GET_OS_INFO()
 
-# CMAKE_C_COMPILER_ID and CMAKE_CXX_COMPILER_ID are documented as internal variables subject to
-# change at: http://www.cmake.org/cmake/help/v2.8.8/cmake.html#variable:CMAKE_LANG_COMPILER_ID
-# however currently this seems the most robust way to detect the presence of the Clang compiler
+
+# detect if using the Clang compiler
 if("${CMAKE_C_COMPILER_ID}" MATCHES "Clang")
   set(CMAKE_COMPILER_IS_CLANG 1)
 endif ()
@@ -54,6 +53,9 @@
 option(BUILD_PYTHON_BINDINGS "Build Python bindings" ON)
 option(BUILD_MATLAB_BINDINGS "Build Matlab bindings" ON)
 option(BUILD_CUDA_LIB "Build CUDA library" OFF)
+option(BUILD_EXAMPLES "Build examples" ON)
+option(BUILD_TESTS "Build tests" ON)
+option(BUILD_DOC "Build documentation" ON)
 option(USE_OPENMP "Use OpenMP multi-threading" ON)
 option(USE_MPI "Use MPI" OFF)
 
@@ -141,23 +143,29 @@
 endif(BUILD_CUDA_LIB)
 
 #set the C/C++ include path to the "include" directory
-include_directories(${PROJECT_SOURCE_DIR}/src/cpp)
+include_directories(BEFORE ${PROJECT_SOURCE_DIR}/src/cpp)
 
 # require proper c++
 #add_definitions( "-Wall -ansi -pedantic" )
 # HDF5 uses long long which is not ansi
-if (WIN32)
+if(CMAKE_C_COMPILER_ID MATCHES "MSVC" OR CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
     # lots of warnings with cl.exe right now, use /W1
     add_definitions("/W1 -D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS /bigobj")
-else(WIN32)
+else()
     add_definitions( "-Wall -Wno-unknown-pragmas -Wno-unused-function" )
-endif(WIN32)
+endif()
 
 add_subdirectory( cmake )
 add_subdirectory( src )
-add_subdirectory( examples )
-add_subdirectory( test )
-add_subdirectory( doc )
+if (BUILD_EXAMPLES)
+  add_subdirectory( examples )
+endif(BUILD_EXAMPLES)
+if (BUILD_TESTS)
+  add_subdirectory( test )
+endif (BUILD_TESTS)
+if (BUILD_DOC)
+  add_subdirectory( doc )
+endif (BUILD_DOC)
 
 
 # CPACK options
@@ -200,6 +208,9 @@
 message(STATUS "Install prefix: ${CMAKE_INSTALL_PREFIX}")
 message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")
 message(STATUS "Building C bindings: ${BUILD_C_BINDINGS}")
+message(STATUS "Building examples: ${BUILD_EXAMPLES}")
+message(STATUS "Building tests: ${BUILD_TESTS}")
+message(STATUS "Building documentation: ${BUILD_DOC}")
 message(STATUS "Building python bindings: ${BUILD_PYTHON_BINDINGS}")
 message(STATUS "Building matlab bindings: ${BUILD_MATLAB_BINDINGS}")
 message(STATUS "Building CUDA library: ${BUILD_CUDA_LIB}")

=== cmake/CMakeLists.txt ===
set(PKG_DESC "Fast Library for Approximate Nearest Neighbors")
set(pkg_conf_file ${CMAKE_CURRENT_BINARY_DIR}/flann.pc)
configure_file(flann.pc.in ${pkg_conf_file} @ONLY)
install(FILES ${pkg_conf_file}
    DESTINATION ${FLANN_LIB_INSTALL_DIR}/pkgconfig/ COMPONENT pkgconfig)

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,8 @@
 find_package(LATEX)
+
+if (NOT DOCDIR)
+  set(DOCDIR share/doc/flann)
+endif ()
  
 if (EXISTS ${PDFLATEX_COMPILER} AND EXISTS ${BIBTEX_COMPILER})
     include(${PROJECT_SOURCE_DIR}/cmake/UseLATEX.cmake)
@@ -14,6 +18,6 @@
 
 install(
     FILES manual.pdf
-    DESTINATION share/doc/flann
+    DESTINATION ${DOCDIR}
     OPTIONAL
 )

=== src/CMakeLists.txt ===

add_subdirectory( cpp )

if (BUILD_MATLAB_BINDINGS)
    add_subdirectory( matlab )
endif()

if (BUILD_PYTHON_BINDINGS)
    add_subdirectory( python )
endif()

=== test/CMakeLists.txt ===

add_custom_target(tests)
add_custom_target(flann_gtests)
add_custom_target(test)
add_custom_target(flann_gtest)

add_dependencies(tests flann_gtests)
add_dependencies(test flann_gtest)
add_dependencies(test tests)

set(EXECUTABLE_OUTPUT_PATH ${TEST_OUTPUT_PATH})

if (PYTHON_EXECUTABLE) 
    flann_download_test_data(sift10K.h5 0964a910946d2dd5fe28337507a8abc3)
    flann_download_test_data(sift10K_byte.h5 f835e0148df4618a81f67febfda2b4d0)
    flann_download_test_data(sift100K.h5 ae2b08f93f3d9f89f5d68566b0406102)
    flann_download_test_data(sift100K_byte.h5 b772255fd2044e9d2a5a0183953e4705)
    flann_download_test_data(cloud.h5 dfc77bad391a3ae739a9874f4a5dc0d7)
    flann_download_test_data(brief100K.h5 e1e781c0955917bc2f0a27b6344c2342)
endif()

if (GTEST_FOUND AND HDF5_FOUND)
    include_directories(${HDF5_INCLUDE_DIR})

    set(TEST_LIBRARIES "${HDF5_LIBRARIES}")
    if (HDF5_IS_PARALLEL)
        set(TEST_LIBRARIES "${TEST_LIBRARIES};${MPI_LIBRARIES}")
    endif()

    flann_add_gtest(flann_linear_test flann_linear_test.cpp)
    target_link_libraries(flann_linear_test flann_cpp ${TEST_LIBRARIES})

    flann_add_gtest(flann_kdtree_test flann_kdtree_test.cpp)
    target_link_libraries(flann_kdtree_test flann_cpp ${TEST_LIBRARIES})

    flann_add_gtest(flann_kmeans_test flann_kmeans_test.cpp)
    target_link_libraries(flann_kmeans_test flann_cpp ${TEST_LIBRARIES})

    flann_add_gtest(flann_kdtree_single_test flann_kdtree_single_test.cpp)
    target_link_libraries(flann_kdtree_single_test flann_cpp ${TEST_LIBRARIES})

    flann_add_gtest(flann_hierarchical_test flann_hierarchical_test.cpp)
    target_link_libraries(flann_hierarchical_test flann_cpp ${TEST_LIBRARIES})

    flann_add_gtest(flann_lsh_test flann_lsh_test.cpp)
    target_link_libraries(flann_lsh_test flann_cpp ${TEST_LIBRARIES})

    flann_add_gtest(flann_autotuned_test flann_autotuned_test.cpp)
    target_link_libraries(flann_autotuned_test flann_cpp ${TEST_LIBRARIES})

    if (OPENMP_FOUND)
        flann_add_gtest(flann_multithreaded_test flann_multithreaded_test.cpp)
        target_link_libraries(flann_multithreaded_test flann_cpp ${TEST_LIBRARIES})
    endif()

endif()

if (GTEST_FOUND AND HDF5_FOUND AND BUILD_CUDA_LIB)
    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS};-Xcompiler;-fPIC;-arch=sm_13" )
    if (NVCC_COMPILER_BINDIR)
        set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS};--compiler-bindir=${NVCC_COMPILER_BINDIR}")
    endif()
    flann_add_cuda_gtest(flann_cuda_test flann_cuda_test.cu)
    target_link_libraries(flann_cuda_test flann_cpp ${HDF5_LIBRARIES} flann_cuda)
endif()


#---------- pyunit tests --------------
if (BUILD_PYTHON_BINDINGS) 
    flann_add_pyunit(test_nn.py)
    flann_add_pyunit(test_nn_index.py)
    flann_add_pyunit(test_index_save.py)
    flann_add_pyunit(test_nn_autotune.py)
    flann_add_pyunit(test_clustering.py)
endif()

#---------- ruby spec ----------------
if (BUILD_C_BINDINGS)
    add_custom_target(flann_ruby_spec
                    COMMAND bundle exec rake spec
                    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/src/ruby)
    add_dependencies(test flann_ruby_spec)
endif()

=== src/cpp/CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,11 @@
-#include_directories(${CMAKE_SOURCE_DIR}/include algorithms util nn .)
+#include_directories(${CMAKE_SOURCE_DIR}/include algorithms ext util nn .)
 
 add_definitions(-D_FLANN_VERSION=${FLANN_VERSION})
 
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/flann/config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/flann/config.h)
 
-file(GLOB_RECURSE C_SOURCES flann.cpp)
-file(GLOB_RECURSE CPP_SOURCES flann_cpp.cpp)
+file(GLOB_RECURSE C_SOURCES flann.cpp lz4.c lz4hc.c)
+file(GLOB_RECURSE CPP_SOURCES flann_cpp.cpp lz4.c lz4hc.c)
 file(GLOB_RECURSE CU_SOURCES *.cu)
 
 add_library(flann_cpp_s STATIC ${CPP_SOURCES})
@@ -15,14 +15,14 @@
 set_property(TARGET flann_cpp_s PROPERTY COMPILE_DEFINITIONS FLANN_STATIC FLANN_USE_CUDA)
 
 if (BUILD_CUDA_LIB)
-    SET(CUDA_NVCC_FLAGS -DFLANN_USE_CUDA)
+    SET(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS};-DFLANN_USE_CUDA")
     if(CMAKE_COMPILER_IS_GNUCC)
-		set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS};-Xcompiler;-fPIC;-arch=sm_13" )
+		set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS};-Xcompiler;-fPIC;" )
         if (NVCC_COMPILER_BINDIR)
             set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS};--compiler-bindir=${NVCC_COMPILER_BINDIR}")
         endif()
     else()
-	    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS};-arch=sm_13" )
+	    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS};" )
     endif()
     cuda_add_library(flann_cuda_s STATIC ${CU_SOURCES})
     set_property(TARGET flann_cuda_s PROPERTY COMPILE_DEFINITIONS FLANN_STATIC)
@@ -52,14 +52,14 @@
    VERSION ${FLANN_VERSION}
    SOVERSION ${FLANN_SOVERSION}
    DEFINE_SYMBOL FLANN_EXPORTS
-) 
+)
 
 if (BUILD_CUDA_LIB)
     set_target_properties(flann_cuda PROPERTIES
        VERSION ${FLANN_VERSION}
        SOVERSION ${FLANN_SOVERSION}
        DEFINE_SYMBOL FLANN_EXPORTS
-    ) 
+    )
 endif()
 
 
@@ -88,17 +88,21 @@
         target_link_libraries(flann -Wl,-whole-archive flann_s -Wl,-no-whole-archive)
     else()
         add_library(flann SHARED ${C_SOURCES})
+
+        if(MINGW AND OPENMP_FOUND)
+          target_link_libraries(flann gomp)
+        endif()
     endif()
 
     set_target_properties(flann PROPERTIES
        VERSION ${FLANN_VERSION}
        SOVERSION ${FLANN_SOVERSION}
        DEFINE_SYMBOL FLANN_EXPORTS
-    ) 
+    )
 endif()
 
 if(WIN32)
-if (BUILD_C_BINDINGS)
+if (BUILD_C_BINDINGS AND BUILD_MATLAB_BINDINGS)
     install (
         TARGETS flann
         RUNTIME DESTINATION share/flann/matlab
@@ -113,7 +117,7 @@
     LIBRARY DESTINATION ${FLANN_LIB_INSTALL_DIR}
     ARCHIVE DESTINATION ${FLANN_LIB_INSTALL_DIR}
 )
- 
+
 if (BUILD_CUDA_LIB)
     install (
         TARGETS flann_cuda flann_cuda_s

=== src/python/CMakeLists.txt ===
configure_file( setup.py.tpl setup.py )

install( DIRECTORY pyflann DESTINATION share/flann/python )
install( FILES ${CMAKE_CURRENT_BINARY_DIR}/setup.py DESTINATION share/flann/python )


# python instalation
if (PYTHON_EXECUTABLE)
    install(CODE "execute_process(
        COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/setup.py install
        WORKING_DIRECTORY \"${CMAKE_CURRENT_SOURCE_DIR}\")")
endif()

=== debian/control ===
Source: flann
Section: libs
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Michael Kleiber <mike@kleibi.de>,
	   Leopold Palomo-Avellaneda <leo@alaxarxa.net>
Build-Depends: cmake,
               debhelper-compat (= 12),
               pkg-config,
               libboost-dev,
               libboost-mpi-dev,
               libboost-system-dev,
               libboost-serialization-dev,
               libboost-thread-dev,
               libgtest-dev,
               libhdf5-mpi-dev,
               liblz4-dev,
               mpi-default-dev,
Build-Depends-Indep: latex2html, texlive-binaries, texlive-latex-base
Standards-Version: 4.4.1
Rules-Requires-Root: no
Homepage: http://www.cs.ubc.ca/research/flann/
Vcs-Browser: https://salsa.debian.org/science-team/flann
Vcs-Git: https://salsa.debian.org/science-team/flann.git

Package: libflann-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libflann1.9 (= ${binary:Version}), ${misc:Depends}, libboost-dev, libhdf5-mpi-dev, liblz4-dev,
Description: Fast Library for Approximate Nearest Neighbors - development
 FLANN is a library for performing fast approximate nearest neighbor searches
 in high dimensional spaces. It contains a collection of algorithms found
 to work best for nearest neighbor search and a system for automatically
 choosing the best algorithm and optimum parameters depending on the dataset.
 .
 This package contains development files needed to build FLANN applications.

Package: libflann1.9
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Fast Library for Approximate Nearest Neighbors - runtime
 FLANN is a library for performing fast approximate nearest neighbor searches
 in high dimensional spaces. It contains a collection of algorithms found
 to work best for nearest neighbor search and a system for automatically
 choosing the best algorithm and optimum parameters depending on the dataset.
 .
 This package contains the libraries needed to run FLANN applications.

Package: flann-doc
Architecture: all
Section: doc
Depends: doc-base, ${misc:Depends}
Description: Fast Library for Approximate Nearest Neighbors - documentation
 FLANN is a library for performing fast approximate nearest neighbor searches
 in high dimensional spaces. It contains a collection of algorithms found
 to work best for nearest neighbor search and a system for automatically
 choosing the best algorithm and optimum parameters depending on the dataset.
 .
 This package contains the documentation for FLANN.

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,16 @@
 
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
+export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
+
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+
+DEB_BUILD_ARCH     ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
+
+ifneq (,$(filter $(DEB_BUILD_ARCH),mips mipsel))
+	export DEB_CXXFLAGS_MAINT_APPEND = -g1
+override_dh_dwz:
+endif
 
 CMAKE_FLAGS = \
 	-DCMAKE_BUILD_TYPE:STRING=None \
@@ -11,11 +20,12 @@
 	-DBUILD_PYTHON_BINDINGS:BOOL=OFF \
 	-DUSE_MPI:BOOL=ON \
 	-DUSE_OPENMP:BOOL=ON \
-	-DFLANN_LIB_INSTALL_DIR:STRING="lib/$(DEB_HOST_MULTIARCH)" \
+	-DLIB_SUFFIX:STRING="/$(DEB_HOST_MULTIARCH)" \
+	-DBUILD_TESTS:BOOL=ON \
 	-DBUILD_CUDA_LIB:BOOL=OFF
 
 %:
-	dh $@ --parallel
+	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure -- $(CMAKE_FLAGS)
@@ -32,6 +42,3 @@
 
 # No tests needed for docs
 override_dh_auto_test-indep:
-
-get-orig-source:
-	uscan --verbose --force-download --repack --rename

=== debian/watch ===
version=3
opts=dversionmangle=s/\.dfsg//,repacksuffix=+dfsg,\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/flann-$1\.tar\.gz/ \
  https://github.com/mariusmuja/flann/releases .*/v?(\d\S*)\.tar\.gz

## flann 1.9.2%2Bdfsg

=== debian/changelog ===
flann (1.9.2+dfsg-1+deb12u1) bookworm; urgency=medium

  * Drop extra -llz4 from flann.pc (already in Requires:) (Closes: #1052649)

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 26 Sep 2023 12:15:32 +0200

flann (1.9.2+dfsg-1) unstable; urgency=medium

  * New upstream version 1.9.2+dfsg
  * Update d/copyright
  * Bump policy version (no changes)
  * Move package description to source package
  * Rebase patches
  * Simplify cmake flags
  * Install cmake files

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 01 Jan 2023 10:52:42 +0100

flann (1.9.1+dfsg-11) unstable; urgency=medium

  * Add d/not-installed
  * Drop special arch all build

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 04 Nov 2021 12:27:14 +0100

flann (1.9.1+dfsg-10) unstable; urgency=medium

  * Drop as-needed, done by default
  * Switch watch to /tags
  * Drop gitlab-ci
  * Add myself to uploaders
  * Update Maintainers name
  * Update Uploaders
  * Bump policy and debhelper versions
  * Add patch for flann.pc

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 04 Nov 2021 10:14:00 +0100

## flann 1.9.2+dfsg

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 add_custom_target(examples ALL)
-
 
 if (BUILD_C_BINDINGS)
     add_executable(flann_example_c flann_example.c)
+    target_link_libraries(flann_example_c ${LZ4_LINK_LIBRARIES})
     target_link_libraries(flann_example_c flann)
     set_target_properties(flann_example_c PROPERTIES COMPILE_FLAGS -std=c99)
 
@@ -14,6 +14,7 @@
     include_directories(${HDF5_INCLUDE_DIR})
 
     add_executable(flann_example_cpp flann_example.cpp)
+    target_link_libraries(flann_example_cpp ${LZ4_LINK_LIBRARIES})
     target_link_libraries(flann_example_cpp ${HDF5_LIBRARIES} flann_cpp)
     if (HDF5_IS_PARALLEL)
         target_link_libraries(flann_example_cpp ${MPI_LIBRARIES})
@@ -25,6 +26,7 @@
 
     if (USE_MPI AND HDF5_IS_PARALLEL)
         add_executable(flann_example_mpi flann_example_mpi.cpp)
+        target_link_libraries(flann_example_mpi ${LZ4_LINK_LIBRARIES})
         target_link_libraries(flann_example_mpi flann_cpp ${HDF5_LIBRARIES} ${MPI_LIBRARIES} ${Boost_LIBRARIES})
 
         add_dependencies(examples flann_example_mpi)

=== src/cpp/CMakeLists.txt ===
--- 
+++ 
@@ -4,11 +4,12 @@
 
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/flann/config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/flann/config.h)
 
-file(GLOB_RECURSE C_SOURCES flann.cpp lz4.c lz4hc.c)
-file(GLOB_RECURSE CPP_SOURCES flann_cpp.cpp lz4.c lz4hc.c)
+file(GLOB_RECURSE C_SOURCES flann.cpp)
+file(GLOB_RECURSE CPP_SOURCES flann_cpp.cpp)
 file(GLOB_RECURSE CU_SOURCES *.cu)
 
 add_library(flann_cpp_s STATIC ${CPP_SOURCES})
+target_link_libraries(flann_cpp_s ${LZ4_LINK_LIBRARIES})
 if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_CLANG)
     set_target_properties(flann_cpp_s PROPERTIES COMPILE_FLAGS -fPIC)
 endif()
@@ -29,21 +30,23 @@
 endif()
 
 if(CMAKE_SYSTEM_NAME STREQUAL "Linux" AND CMAKE_COMPILER_IS_GNUCC)
-    add_library(flann_cpp SHARED "")
+    add_library(flann_cpp SHARED dummy.c)
     set_target_properties(flann_cpp PROPERTIES LINKER_LANGUAGE CXX)
     target_link_libraries(flann_cpp -Wl,-whole-archive flann_cpp_s -Wl,-no-whole-archive)
 
     if (BUILD_CUDA_LIB)
-	    cuda_add_library(flann_cuda SHARED "")
+	cuda_add_library(flann_cuda SHARED dummy.c)
         set_target_properties(flann_cuda PROPERTIES LINKER_LANGUAGE CXX)
         target_link_libraries(flann_cuda -Wl,-whole-archive flann_cuda_s -Wl,-no-whole-archive)
         set_property(TARGET flann_cpp_s PROPERTY COMPILE_DEFINITIONS FLANN_USE_CUDA)
-    # 	target_link_libraries(flann_cuda cudpp_x86_64)
     endif()
 else()
     add_library(flann_cpp SHARED ${CPP_SOURCES})
+    target_link_libraries(flann_cpp ${LZ4_LINK_LIBRARIES})
+    # export lz4 headers, so that MSVC to creates flann_cpp.lib
+    set_target_properties(flann_cpp PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS YES)
     if (BUILD_CUDA_LIB)
-		cuda_add_library(flann_cuda SHARED ${CPP_SOURCES})
+	cuda_add_library(flann_cuda SHARED ${CU_SOURCES})
         set_property(TARGET flann_cpp PROPERTY COMPILE_DEFINITIONS FLANN_USE_CUDA)
     endif()
 endif()
@@ -77,17 +80,19 @@
 
 if (BUILD_C_BINDINGS)
     add_library(flann_s STATIC ${C_SOURCES})
+    target_link_libraries(flann_s ${LZ4_LINK_LIBRARIES})
     if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_CLANG)
         set_target_properties(flann_s PROPERTIES COMPILE_FLAGS -fPIC)
     endif()
     set_property(TARGET flann_s PROPERTY COMPILE_DEFINITIONS FLANN_STATIC)
 
     if(CMAKE_SYSTEM_NAME STREQUAL "Linux" AND CMAKE_COMPILER_IS_GNUCC)
-        add_library(flann SHARED "")
+        add_library(flann SHARED dummy.c)
         set_target_properties(flann PROPERTIES LINKER_LANGUAGE CXX)
         target_link_libraries(flann -Wl,-whole-archive flann_s -Wl,-no-whole-archive)
     else()
         add_library(flann SHARED ${C_SOURCES})
+        target_link_libraries(flann ${LZ4_LINK_LIBRARIES})
 
         if(MINGW AND OPENMP_FOUND)
           target_link_libraries(flann gomp)
@@ -113,6 +118,8 @@
 
 install (
     TARGETS flann_cpp flann_cpp_s
+    EXPORT ${targets_export_name}
+    INCLUDES DESTINATION include
     RUNTIME DESTINATION bin
     LIBRARY DESTINATION ${FLANN_LIB_INSTALL_DIR}
     ARCHIVE DESTINATION ${FLANN_LIB_INSTALL_DIR}
@@ -121,6 +128,8 @@
 if (BUILD_CUDA_LIB)
     install (
         TARGETS flann_cuda flann_cuda_s
+        EXPORT ${targets_export_name}
+        INCLUDES DESTINATION include
         RUNTIME DESTINATION bin
         LIBRARY DESTINATION ${FLANN_LIB_INSTALL_DIR}
         ARCHIVE DESTINATION ${FLANN_LIB_INSTALL_DIR}
@@ -130,6 +139,8 @@
 if (BUILD_C_BINDINGS)
     install (
         TARGETS flann flann_s
+        EXPORT ${targets_export_name}
+        INCLUDES DESTINATION include
         RUNTIME DESTINATION bin
         LIBRARY DESTINATION ${FLANN_LIB_INSTALL_DIR}
         ARCHIVE DESTINATION ${FLANN_LIB_INSTALL_DIR}

=== debian/changelog ===
flann (1.9.2+dfsg-4) unstable; urgency=medium

  * Fix FTBFS with CMake 4 for real

 -- Timo Röhling <roehling@debian.org>  Sat, 27 Sep 2025 01:33:28 +0200

flann (1.9.2+dfsg-3) unstable; urgency=medium

  * Wrap and sort Debian package files
  * Bump Standards-Version to 4.7.2
  * Override CMake policy minimum version (Closes: #1112916, #751854)
  * Replace obsolete pkg-config dependency with pkgconf
  * Add myself to uploaders

 -- Timo Röhling <roehling@debian.org>  Tue, 09 Sep 2025 13:06:59 +0200

flann (1.9.2+dfsg-2) unstable; urgency=medium

  * Drop extra -llz4 from flann.pc (already in Requires:) (Closes: #1052649)

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 26 Sep 2023 11:38:36 +0200

=== debian/control ===
Source: flann
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Leopold Palomo-Avellaneda <leo@alaxarxa.net>,
 Jochen Sprickerhof <jspricke@debian.org>,
 Timo Röhling <roehling@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 latex2html,
 libboost-dev,
 libboost-mpi-dev,
 libboost-serialization-dev,
 libboost-system-dev,
 libboost-thread-dev,
 libgtest-dev,
 libhdf5-mpi-dev,
 liblz4-dev,
 mpi-default-dev,
 pkgconf,
 texlive-binaries,
 texlive-latex-base,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: http://www.cs.ubc.ca/research/flann/
Vcs-Browser: https://salsa.debian.org/science-team/flann
Vcs-Git: https://salsa.debian.org/science-team/flann.git
Description: Fast Library for Approximate Nearest Neighbors
 FLANN is a library for performing fast approximate nearest neighbor searches
 in high dimensional spaces. It contains a collection of algorithms found
 to work best for nearest neighbor search and a system for automatically
 choosing the best algorithm and optimum parameters depending on the dataset.

Package: libflann-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libboost-dev,
 libflann1.9 (= ${binary:Version}),
 libhdf5-mpi-dev,
 liblz4-dev,
 ${misc:Depends},
Description: ${source:Synopsis} - development
 ${source:Extended-Description}
 .
 This package contains development files needed to build FLANN applications.

Package: flann-doc
Architecture: all
Section: doc
Depends:
 doc-base,
 ${misc:Depends},
Description: ${source:Synopsis} - documentation
 ${source:Extended-Description}
 .
 This package contains the documentation for FLANN.

Package: libflann1.9
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Multi-Arch: same
Description: ${source:Synopsis} - runtime
 ${source:Extended-Description}
 .
 This package contains the libraries needed to run FLANN applications.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

ifneq (,$(filter $(DEB_BUILD_ARCH),mips mipsel))
	export DEB_CXXFLAGS_MAINT_APPEND = -g1
override_dh_dwz:
endif

CMAKE_FLAGS = \
	-DBUILD_MATLAB_BINDINGS=OFF \
	-DBUILD_PYTHON_BINDINGS=OFF \
	-DUSE_MPI=ON \
	-DUSE_OPENMP=ON \
	-DBUILD_TESTS=ON \
	-DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
	-DBUILD_CUDA_LIB=OFF

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

# test download material from the net. Removing them.
override_dh_auto_test:

override_dh_compress:
	dh_compress --exclude=.pdf

execute_after_dh_auto_build:
	$(MAKE) -C obj-* doc

=== debian/watch ===
version=4
opts=dversionmangle=s/\.dfsg//,repacksuffix=+dfsg,\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/@PACKAGE@-$1\.tar\.gz/ \
  https://github.com/mariusmuja/flann/tags .*/v?(\d\S*)\.tar\.gz
